// Mod: Special Days for Xin Calendar 2 (In-Page/Popup-Window)
// Copyright 2004  Xin Yang    All Rights Reserved.

// Last Modified: 16-Dec-2005

// User interface
function setLoopWeek(confName,cssDateSpecial,cssDateSpecialDisabled,startWeek,weekOffset) {
  var dayIndex=0;

  for (var i=5; i<setLoopWeek.arguments.length; i++) {
    if (setLoopWeek.arguments[i].search(/(sun|mon|tue|wed|thu|fri|sat)/i)!=-1) {
      dayIndex=xcDayFromName(RegExp.$1);

      for (j=startWeek-1; j<6; j+=weekOffset) {
        xcRegisterConf(confName,"specialDays",j+":"+dayIndex,[cssDateSpecial,cssDateSpecialDisabled],0);

        if (dayIndex==0) {
          xcRegisterConf(confName,"specialDays",j+":7",[cssDateSpecial,cssDateSpecialDisabled],0);
        }
      }
    }
  }
}

function setLoopMonth(confName,cssDateSpecial,cssDateSpecialDisabled,startMonth,monthOffset) {
  for (var i=5; i<setLoopMonth.arguments.length; i++) {
    for (j=startMonth-1; j<12; j+=monthOffset) {
      xcRegisterConf(confName,"specialDays",xcGetDD(j)+":"+xcGetDD(setLoopMonth.arguments[i]),[cssDateSpecial,cssDateSpecialDisabled],0);
    }
  }
}

function setLoopYear(confName,cssDateSpecial,cssDateSpecialDisabled,dateFormat) {
  var m,d,arg;
  var mmIdx=dateFormat.search(/mm/i), monIdx=dateFormat.search(/mon/i), ddIdx=dateFormat.search(/dd/i);
  var dateFormatRE=new RegExp('^'+_xcGetDateFormatRE(dateFormat)+'$');

  for (var i=4; i<setLoopYear.arguments.length; i++) {
    arg=setLoopYear.arguments[i];

    if (dateFormatRE.test(arg)) {
      if (mmIdx!=-1) {
        m=arg.substring(mmIdx, mmIdx+2)-1;
      }
      else {
        m=xcMonthFromName(arg.substring(monIdx, monIdx+3));
      }
      d=arg.substring(ddIdx, ddIdx+2)-0;

      xcRegisterConf(confName,"specialDays",xcGetDD(m)+":"+xcGetDD(d),[cssDateSpecial,cssDateSpecialDisabled],0);
    }
  }
}

// Mod function
function xcSpecialDays(cal) {
  return cal.getConf("specialDays",xcGetDD(cal.cellMonth)+":"+xcGetDD(cal.cellDate)) || cal.getConf("specialDays",cal.cellWeek+":"+cal.cellDay);
}

xcSpecialCalls[xcSpecialCalls.length]=xcSpecialDays;
